function onHelp()
{
  window.open('discreteGaussianFilterHelp.html','discreteGaussianFilterHelp','menubar=no,width=800,resizable=yes,toolbar=no,location=no,directories=no,status=no');
}

function onLoad()
{
  
  // extract threshold filter options into variables
  window.discreteGaussianFilter = window.arguments[0].discreteGaussianFilter;

	// set up preview window
	window.previewWindow = new previewWindow(window.discreteGaussianFilter,"window.previewWindow")

  var variance = window.discreteGaussianFilter.variance;
  var maxKernelWidth = window.discreteGaussianFilter.maxKernelWidth;
 
  // create objects to reference the sliders 
  var varianceSlider = document.getElementById("variance-slider");
  var maxKernelWidthSlider = document.getElementById("max-kernel-width-slider");

  // set inital position of sliders
  varianceSlider.setAttribute("curpos",variance);
  maxKernelWidthSlider.setAttribute("curpos",maxKernelWidth);
  
  // add listeners to the sliders
  varianceSlider.addEventListener("DOMAttrModified", variance_slider, false);
  maxKernelWidthSlider.addEventListener("DOMAttrModified", max_kernel_width_slider, false);
  
  // set initial values of textboxes
  document.getElementById("variance-textbox").setAttribute("value",variance);
  document.getElementById("max-kernel-width-textbox").setAttribute("value",maxKernelWidth);

 	// refocus window so that fragmented image updates
	// note we have to delay as the window is not actually drawn until AFTER the onload
	// function is executed

	setTimeout('self.focus()',20);
  
}

function onCancel() {
	window.previewWindow.destroyPreviewWindow();
}


// Called once if and only if the user clicks OK
function onOK() {
  // Return the changed arguments.
  // Notice if user clicks cancel, window.arguments[0].out remains null
  // because this function is never called

  // get values of textboxes
  var variance = document.getElementById("variance-textbox").value;
  var maxKernelWidth = document.getElementById("max-kernel-width-textbox").value;
	window.discreteGaussianFilter.variance = variance;
	window.discreteGaussianFilter.maxKernelWidth = maxKernelWidth;

	window.discreteGaussianFilter.apply_filter();

	// update preview window
	window.previewWindow.onPreview();

  return false;
}


function variance_slider()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
  var varianceSlider = document.getElementById("variance-slider");

  // These attributes must be specified in the xul so that they are fetchable
  varianceSlider.value = varianceSlider.getAttribute("curpos");

  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (varianceSlider.previousValue != varianceSlider.value)
    {

      varianceSlider.previousValue = varianceSlider.value;

      window.discreteGaussianFilter.variance = varianceSlider.value;

      // update text box
      document.getElementById("variance-textbox").setAttribute("value",varianceSlider.value);
		
			// update the preview
			window.previewWindow.autoPreview();
    }
}


function max_kernel_width_slider()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
  var maxKernelWidthSlider = document.getElementById("max-kernel-width-slider");

  // These attributes must be specified in the xul so that they are fetchable
  maxKernelWidthSlider.value = maxKernelWidthSlider.getAttribute("curpos");

  // Unfortunately we are grabbing mouse move events and we have to check if 
  // the value has actually changed.
  if (maxKernelWidthSlider.previousValue != maxKernelWidthSlider.value)
    {

      maxKernelWidthSlider.previousValue = maxKernelWidthSlider.value;

      window.discreteGaussianFilter.maxKernelWidth = maxKernelWidthSlider.value;

      // update text box
      document.getElementById("max-kernel-width-textbox").setAttribute("value",maxKernelWidthSlider.value);
		
			// update the preview
			window.previewWindow.autoPreview();
    }
}

